﻿-----------------------------------------------------
-- by Clemens L (c@clemenslenhart.net)
-- created on 03/24/20
-- v 1.0
-----------------------------------------------------
-- Description:
-- changes the values of all CoronaTriplanar maps connected to all materials applied to the selected object.
-----------------------------------------------------

macroScript CTpC category:"CTpC"
(

tpScale = 0
offXvalue = 0
offYvalue = 0
offZvalue = 0
rotXvalue = 0
rotYvalue = 0
rotZvalue = 0
mappingSpace = 0

try(destroyDialog rolMain)catch()
rollout rolMain "CoronaTriplanar Control v1.0"
(

fn changeCTriM = 
(
	for o in selection where o.mat != undefined do
	(
		map = getClassInstances CoronaTriplanar target:o.mat
		if map.count != 0 do for m in map do 
		(
			m.scale = tpScale
			m.offset = [offXvalue,offYvalue,offZvalue]
			m.rotation = [rotXvalue,rotYvalue,rotZvalue]
			m.space = mappingSpace
			
		)
	)
)

label lab3 "scale:" pos:[10,10]
spinner spn7 "" width:55 pos:[89,10] type:#worldunits range:[0,1000000,0]

label lab2 "offset:" pos:[10,30]
spinner spn4 "X:" width:60 pos:[85,30] type:#worldunits range:[-1000000,1000000,0]
spinner spn5 "Y:" width:60 pos:[155,30] type:#worldunits range:[-1000000,1000000,0]
spinner spn6 "Z:" width:60 pos:[225,30] type:#worldunits range:[-1000000,1000000,0]

label lab1 "rotate:" pos:[10,50]
spinner spn1 "X:" width:60 pos:[85,50] range:[-1000000,1000000,0]
spinner spn2 "Y:" width:60 pos:[155,50] range:[-1000000,1000000,0]
spinner spn3 "Z:" width:60 pos:[225,50] range:[-1000000,1000000,0]

label lab4 "mapping space:" pos:[10,73]
dropdownlist dd items:#("Local space", "Reference node space", "World space") selection:1 pos:[90,70] width:195

button isDo "Do" width:115

on spn1 changed val do rotXvalue = val
on spn2 changed val do rotYvalue = val
on spn3 changed val do rotZvalue = val
on spn4 changed val do offXvalue = val
on spn5 changed val do offYvalue = val
on spn6 changed val do offZvalue = val
on spn7 changed val do tpScale = val
on dd selected i do 
	if dd.selected == "Local space" then mappingSpace = 0
		else 
	if dd.selected == "Reference node space" then mappingSpace = 2
		else
	if dd.selected == "World space" then mappingSpace = 1 
on isDO pressed do changeCTriM()

)

CreateDialog rolMain 295 125
)
